#ifndef NUNCHUCK_H
#define NUNCHUCK_H

// Wii Nunchuck via I2C

#include <Wire.h>

#define NUNCHUCK_ZEROX 530  
#define NUNCHUCK_ZEROY 530
#define NUNCHUCK_ZEROZ 530

#define NUNCHUK_I2C_ADDRESS 0x52

int nunchuck_counter;

uint8_t nunchuck_data[6];

int nunchuck_joy_x;
int nunchuck_joy_y;
int nunchuck_buttons;
int nunchuck_acc_x;
int nunchuck_acc_y;
int nunchuck_acc_z;

void nunchuck_setup() {
  //Serial.begin(57600);
  Wire.begin();
  
  Wire.beginTransmission(NUNCHUK_I2C_ADDRESS);
  Wire.write(0xF0);
  Wire.write(0x55);
  Wire.endTransmission();
  
  Wire.beginTransmission(NUNCHUK_I2C_ADDRESS);
  Wire.write(0xFB);
  Wire.write(0x00);
  Wire.endTransmission();
  
  nunchuck_buttons = 0x00;
  nunchuck_joy_x = 0;
  nunchuck_joy_y = 0;
  nunchuck_acc_x = 0;
  nunchuck_acc_y = 0;
  nunchuck_acc_z = 0;
} 

void nunchuck_loop() {
  
  Wire.requestFrom(NUNCHUK_I2C_ADDRESS, 6);
  nunchuck_counter = 0;
  while(Wire.available()) {
    nunchuck_data[nunchuck_counter++] = Wire.read();
  }
  
  Wire.beginTransmission(NUNCHUK_I2C_ADDRESS);
  Wire.write(0x00);
  Wire.endTransmission();

  if(nunchuck_counter >= 5) {
    nunchuck_joy_x = nunchuck_data[0] - 128;
    nunchuck_joy_y = 128 - nunchuck_data[1];
    
    nunchuck_acc_x = ((nunchuck_data[2] << 2) + ((nunchuck_data[5] >> 2) & 0x03) - NUNCHUCK_ZEROX);
    nunchuck_acc_y = ((nunchuck_data[3] << 2) + ((nunchuck_data[5] >> 4) & 0x03) - NUNCHUCK_ZEROY);
    nunchuck_acc_z = ((nunchuck_data[4] << 2) + ((nunchuck_data[5] >> 6) & 0x03) - NUNCHUCK_ZEROZ);
    
    nunchuck_buttons = 0x03 ^ (nunchuck_data[5] & 0x03);
    
    /*
    Serial.print("X="); Serial.print(joyX);
    Serial.print(", Y="); Serial.print(joyY);
    Serial.print(", B="); Serial.print(buttons);

    Serial.print("\t");
    Serial.print("accX="); Serial.print(accelX);
    Serial.print(", accY="); Serial.print(accelY);
    Serial.print(", accZ="); Serial.print(accelZ);
    Serial.println();
    delay(20);
    */
    
  }
}
#endif