
#define USE_GPS // Include serial GPS functionality via NeoICSerial and TinyGPS
#define USE_COMPASS // Include compass functionality using HMC5883
#include "gpsCompass.h"


// Main
#define SERIAL_BAUD 57600
#define put(t) Serial.println(t)
#define put_(t) Serial.print(t)
#define put_float_(f) Serial.print(f, 6)

void on_gpsCompass_position(float x, float y, float z) {
}
void on_gpsCompass_magnet(float lat, float lon, float alt) {
  
  put_(F("Position: "));
  put_float_(lat);
  put_(F(", "));
  put_float_(lon);
  
  put_("\tAltitude: ");
  put_(alt);
  
  //put_("\tHeading: ");
  //put_(gpsCompass_heading_deg);

  put_("\tDate: ");
  put_(gpsCompass_time_year);
  put_('-');
  put_(gpsCompass_time_month);
  put_('-');
  put_(gpsCompass_time_day);

  put_("\tTime: ");
  put(gpsCompass_time_millis);  
}


void setup() {
  Serial.begin(SERIAL_BAUD);

  gpsCompass_setup();
  gpsCompass_on_position = on_gpsCompass_position;
  gpsCompass_on_magnet = on_gpsCompass_magnet;
}


void loop() {

  // Needs to be triggered fast enough for the serial buffer not to overflow
  gpsCompass_loop();
  
  delay(200);
}

