/*
   Leonardo WiiClassicController GamePad by Nguyen Chi Tam, created in March 2017

   This sketch uses some codes from
   https://github.com/TarkanAl-Kazily/Wii_Classic_Controller/blob/master/Wii_Classic_Controller.ino

   and ArduinoJoystickLibrary from Matthew Heironimus
   https://github.com/MHeironimus/ArduinoJoystickLibrary
*/

#include "joystick_WCC.h"


void setup() {
  pinMode(13, OUTPUT); // for testing purpose

  Serial.begin(57600);

  joystick_wcc_setup(true);
}

void loop() {
  
  joystick_wcc_loop();
  
  int dX = (wcc_state.ButtonLeft ? -1 : (wcc_state.ButtonRight ? 1 : 0));
  int dY = (wcc_state.ButtonUp ? 1 : (wcc_state.ButtonDown ? -1 : 0));
  Serial.print("dX="); Serial.print(dX); Serial.print(", ");
  Serial.print("dY="); Serial.print(dY); Serial.print("\t");

  Serial.print("lX="); Serial.print(wcc_state.LeftX); Serial.print(", ");
  Serial.print("lY="); Serial.print(wcc_state.LeftY); Serial.print("\t");
  
  Serial.print("rX="); Serial.print(wcc_state.RightX); Serial.print(", ");
  Serial.print("rY="); Serial.print(wcc_state.RightY); Serial.print("\t");

  Serial.print("Home="); Serial.print(wcc_state.ButtonHome); Serial.print(", ");
  Serial.print("Select="); Serial.print(wcc_state.ButtonSelect); Serial.print(", ");
  Serial.print("Start="); Serial.print(wcc_state.ButtonStart); Serial.print(", ");
  
  Serial.print("L="); Serial.print(wcc_state.ButtonL); Serial.print(", ");
  Serial.print("R="); Serial.print(wcc_state.ButtonR); Serial.print(", ");
  
  Serial.print("ZL="); Serial.print(wcc_state.ButtonZL); Serial.print(", ");
  Serial.print("ZR="); Serial.print(wcc_state.ButtonZR); Serial.print(", ");

  Serial.print("A="); Serial.print(wcc_state.ButtonA); Serial.print(", ");
  Serial.print("B="); Serial.print(wcc_state.ButtonB); Serial.print(", ");
  Serial.print("X="); Serial.print(wcc_state.ButtonX); Serial.print(", ");
  Serial.print("Y="); Serial.print(wcc_state.ButtonY);
  Serial.println();

  delay(50);
}
