#include <Wire.h>

#define ZEROX 530  
#define ZEROY 530
#define ZEROZ 530

#define WII_NUNCHUK_I2C_ADDRESS 0x52

int counter;

uint8_t data[6];

void setup() { 
 
  Wire.begin();

  Wire.beginTransmission(WII_NUNCHUK_I2C_ADDRESS);
  Wire.write(0xF0);
  Wire.write(0x55);
  Wire.endTransmission();

  Wire.beginTransmission(WII_NUNCHUK_I2C_ADDRESS);
  Wire.write(0xFB);
  Wire.write(0x00);
  Wire.endTransmission();
} 

void loop() { 

    Serial.begin(57600);

    
    Wire.requestFrom(WII_NUNCHUK_I2C_ADDRESS, 6);
    counter = 0;
    while(Wire.available()) {
      data[counter++] = Wire.read();
    }
    
    Wire.beginTransmission(WII_NUNCHUK_I2C_ADDRESS);
    Wire.write(0x00);
    Wire.endTransmission();

    if(counter >= 5) {
      int joyX = data[0] - 128;
      int joyY = 128 - data[1];
      
      int accelX = ((data[2] << 2) + ((data[5] >> 2) & 0x03) - ZEROX);
      int accelY = ((data[3] << 2) + ((data[5] >> 4) & 0x03) - ZEROY);
      int accelZ = ((data[4] << 2) + ((data[5] >> 6) & 0x03) - ZEROZ);

      int buttons = 0x03 ^ (data[5] & 0x03);

      Serial.print("X="); Serial.print(joyX);
      Serial.print(", Y="); Serial.print(joyY);
      Serial.print(", B="); Serial.print(buttons);

      Serial.print("\t");
      Serial.print("accX="); Serial.print(accelX);
      Serial.print(", accY="); Serial.print(accelY);
      Serial.print(", accZ="); Serial.print(accelZ);
      Serial.println();
      delay(20);
    }
}
