
#define SERIAL_BAUD 115200
//#define SERIAL_BAUD 230400
//#define SERIAL_BAUD 250000
//#define SERIAL_BAUD 256000

// Configure pybridge (defines before including the h-file):
// Use standard Serial for communication and debugging
#define SerialDebug Serial
#define SerialCommand Serial
//#define DEBUG_VERBOSE

// Select functionality
#define USE_DIGITALS
#define USE_ANALOGS
//#define USE_SERVOS
//#define USE_LEDRGB
//#define LEDRGB_NUM 8+9+8+9
//#define LEDRGB_PIN 6

#define USE_CUSTOM_PACKETS  // Enable pybridge_on_packet callback
#define USE_CUSTOM_COMMANDS // Enable pybridge_on_command callback

#include "pybridge.h"



// Custom low-level protocol handler
byte my_on_packet(byte seq, byte payloadLen, byte *payload) {
  //put(F("my_on_packet"));
  return 0; // 0=Continue, 1=Stop propagation
}


// Custom command
// Define a custom command
#define CMD_CUSTOM_ARDUINO '0'
#define CMD_CUSTOM_PYTHON '1'

byte my_on_command(byte cmd, byte len, byte *data) {
  //put(F("my_on_command"));
  
  switch(cmd) {
    case CMD_CUSTOM_ARDUINO:
      //put(F("CMD_CUSTOM_ARDUINO!"));

      // send another custom in return
      sendCommand_none(CMD_CUSTOM_PYTHON);

      
      // Blink!
      pinMode(13, OUTPUT);
      for (int i = 0; i < 8; i++) {
        digitalWrite(13, HIGH);  delay(100);
        digitalWrite(13, LOW);   delay(100);
      }
      
      return 1; // Stop propagation
      break;
      
  }
  
  return 0; // 0=Continue, 1=Stop propagation
}



// Main implementation
//#define USE_LED // Blink in main loop?
#define PIN_OUT_LED 13
#define LOOP_DELAY 1


void setup() {
  #ifdef USE_LED
    pinMode(PIN_OUT_LED, OUTPUT);
    digitalWrite(PIN_OUT_LED, HIGH);
  #endif

  // Prepare serial port
  Serial.begin(SERIAL_BAUD);
  while (!Serial) {
    ; // wait for serial port to connect. Needed for native USB port only
  }
  //put(F("pybridge tester"));
  
  // Set callbacks
  //pybridge_on_packet = my_on_packet;
  pybridge_on_command = my_on_command;
  
  // Setup pybridge
  pybridge_setup();
  

  //put(F("Ready"));
  sendCommand_none(CMD_READY);

  #ifdef USE_LED
    digitalWrite(PIN_OUT_LED, LOW);
  #endif
}



void loop() {
  #ifdef USE_LED
    digitalWrite(PIN_OUT_LED, HIGH);
  #endif

  pybridge_loop();

  #ifdef USE_LED
    digitalWrite(PIN_OUT_LED, LOW);
  #endif
  
  #if LOOP_DELAY > 0
  delay(LOOP_DELAY);
  #endif
}


